* gas/macros/semi.s: Force the final alignment to use a fill value
[deliverable/binutils-gdb.git] / configure.in
... / ...
CommitLineData
1#! /bin/bash
2##############################################################################
3
4## This file is a shell script fragment that supplies the information
5## necessary to tailor a template configure script into the configure
6## script appropriate for this directory. For more information, check
7## any existing configure script.
8
9## Be warned, there are two types of configure.in files. There are those
10## used by Autoconf, which are macros which are expanded into a configure
11## script by autoconf. The other sort, of which this is one, is executed
12## by Cygnus configure.
13
14## For more information on these two systems, check out the documentation
15## for 'Autoconf' (autoconf.texi) and 'Configure' (configure.texi).
16
17# Copyright (C) 1992, 93, 94, 95, 1996 Free Software Foundation, Inc.
18#
19# This file is free software; you can redistribute it and/or modify it
20# under the terms of the GNU General Public License as published by
21# the Free Software Foundation; either version 2 of the License, or
22# (at your option) any later version.
23#
24# This program is distributed in the hope that it will be useful, but
25# WITHOUT ANY WARRANTY; without even the implied warranty of
26# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU
27# General Public License for more details.
28#
29# You should have received a copy of the GNU General Public License
30# along with this program; if not, write to the Free Software
31# Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
32
33##############################################################################
34
35### To add a new directory to the tree, first choose whether it is a target
36### or a host dependent tool. Then put it into the appropriate list
37### (library or tools, host or target), doing a dependency sort. For
38### example, gdb requires that byacc (or bison) be built first, so it is in
39### the ${host_tools} list after byacc and bison.
40
41
42# these libraries are used by various programs built for the host environment
43#
44host_libs="mmalloc libiberty opcodes bfd readline gash tcl tk tclX"
45
46if [ "${enable_gdbgui}" = "yes" ] ; then
47 host_libs="${host_libs} libgui"
48fi
49
50# these tools are built for the host environment
51#
52host_tools="texinfo byacc flex bison binutils ld gas gcc gdb make patch prms send-pr gprof gdbtest tgas etc expect dejagnu sim bash m4 autoconf ispell grep diff rcs cvs fileutils shellutils time textutils wdiff find emacs emacs19 uudecode hello tar gzip indent recode release sed utils guile perl apache inet gawk findutils"
53
54
55# these libraries are built for the target environment, and are built after
56# the host libraries and the host tools (which may be a cross compiler)
57#
58target_libs="target-libiberty target-libgloss target-newlib target-libio target-librx target-libstdc++ target-libg++"
59
60
61# these tools are built using the target libs, and are intended to run only
62# in the target environment
63#
64# note: any program that *uses* libraries that are in the "target_libs"
65# list belongs in this list. those programs are also very likely
66# candidates for the "native_only" list which follows
67#
68target_tools="target-examples target-groff"
69
70################################################################################
71
72## These two lists are of directories that are to be removed from the
73## ${configdirs} list for either cross-compilations or for native-
74## compilations. For example, it doesn't make that much sense to
75## cross-compile Emacs, nor is it terribly useful to compile target-libiberty in
76## a native environment.
77
78# directories to be built in the native environment only
79#
80# This must be a single line because of the way it is searched by grep in
81# the code below.
82native_only="autoconf cvs emacs emacs19 fileutils find gawk grep gzip hello indent ispell m4 rcs recode sed shellutils tar textutils gash uudecode wdiff gprof target-groff guile perl apache inet time bash prms"
83
84# directories to be built in a cross environment only
85#
86cross_only="target-libiberty target-libgloss target-newlib"
87
88## All tools belong in one of the four categories, and are assigned above
89## We assign ${configdirs} this way to remove all embedded newlines. This
90## is important because configure will choke if they ever get through.
91## ${configdirs} is directories we build using the host tools.
92## ${target_configdirs} is directories we build using the target tools.
93#
94configdirs=`echo ${host_libs} ${host_tools}`
95target_configdirs=`echo ${target_libs} ${target_tools}`
96
97################################################################################
98
99srctrigger=move-if-change
100srcname="gnu development package"
101
102# This gets set non-empty for some net releases of packages.
103appdirs=""
104
105# per-host:
106
107# Work in distributions that contain no compiler tools, like Autoconf.
108if [ -d ${srcdir}/config ]; then
109case "${host}" in
110 m68k-hp-hpux*) host_makefile_frag=config/mh-hp300 ;;
111 m68k-apollo-sysv*) host_makefile_frag=config/mh-apollo68 ;;
112 m68k-apollo-bsd*) host_makefile_frag=config/mh-a68bsd ;;
113 m88k-dg-dgux*) host_makefile_frag=config/mh-dgux ;;
114 m88k-harris-cxux*) host_makefile_frag=config/mh-cxux ;;
115 m88k-motorola-sysv*) host_makefile_frag=config/mh-delta88;;
116 mips*-dec-ultrix*) host_makefile_frag=config/mh-decstation ;;
117 mips*-nec-sysv4*) host_makefile_frag=config/mh-necv4 ;;
118 mips*-sgi-irix6*) host_makefile_frag=config/mh-irix6 ;;
119 mips*-sgi-irix5*) host_makefile_frag=config/mh-irix5 ;;
120 mips*-sgi-irix4*) host_makefile_frag=config/mh-irix4 ;;
121 mips*-sgi-irix3*) host_makefile_frag=config/mh-sysv ;;
122 mips*-*-sysv4*) host_makefile_frag=config/mh-sysv4 ;;
123 mips*-*-sysv*) host_makefile_frag=config/mh-riscos ;;
124 i[3456]86-*-dgux*) host_makefile_frag=config/mh-dgux386 ;;
125 i[3456]86-ncr-sysv4.3) host_makefile_frag=config/mh-ncrsvr43 ;;
126 i[3456]86-ncr-sysv4*) host_makefile_frag=config/mh-ncr3000 ;;
127 i[3456]86-*-sco3.2v5*) host_makefile_frag=config/mh-sysv ;;
128 i[3456]86-*-sco*) host_makefile_frag=config/mh-sco ;;
129 i[3456]86-*-isc*) host_makefile_frag=config/mh-sysv ;;
130 i[3456]86-*-solaris2*) host_makefile_frag=config/mh-sysv4 ;;
131 i[3456]86-*-aix*) host_makefile_frag=config/mh-aix386 ;;
132 i[3456]86-*-go32*) host_makefile_frag=config/mh-go32 ;;
133 *-cygwin32*) host_makefile_frag=config/mh-cygwin32 ;;
134 *-windows*) host_makefile_frag=config/mh-windows ;;
135 vax-*-ultrix2*) host_makefile_frag=config/mh-vaxult2 ;;
136 *-*-solaris2*) host_makefile_frag=config/mh-solaris ;;
137 m68k-sun-sunos*) host_makefile_frag=config/mh-sun3 ;;
138 *-hp-hpux[78]*) host_makefile_frag=config/mh-hpux8 ;;
139 *-hp-hpux*) host_makefile_frag=config/mh-hpux ;;
140 *-*-hiux*) host_makefile_frag=config/mh-hpux ;;
141 rs6000-*-lynxos*) host_makefile_frag=config/mh-lynxrs6k ;;
142 *-*-lynxos*) host_makefile_frag=config/mh-lynxos ;;
143 *-*-sysv4*) host_makefile_frag=config/mh-sysv4 ;;
144 *-*-sysv*) host_makefile_frag=config/mh-sysv ;;
145esac
146fi
147
148# If we aren't going to be using gcc, see if we can extract a definition
149# of CC from the fragment.
150if [ -z "${CC}" -a "${build}" = "${host}" ]; then
151 IFS="${IFS= }"; save_ifs="$IFS"; IFS="${IFS}:"
152 found=
153 for dir in $PATH; do
154 test -z "$dir" && dir=.
155 if test -f $dir/gcc; then
156 found=yes
157 break
158 fi
159 done
160 IFS="$save_ifs"
161 if [ -z "${found}" -a -n "${host_makefile_frag}" -a -f "${srcdir}/${host_makefile_frag}" ]; then
162 xx=`sed -n -e 's/^[ ]*CC[ ]*=[ ]*\(.*\)$/\1/p' < ${srcdir}/${host_makefile_frag}`
163 if [ -n "${xx}" ] ; then
164 CC=$xx
165 fi
166 fi
167fi
168
169# We default to --with-shared on platforms where -fpic is meaningless.
170# Well, we don't yet, but we will.
171if false && [ "${host}" = "${target}" ] && [ x${enable_shared} = x ]; then
172 case "${target}" in
173 alpha-dec-osf*) enable_shared=yes ;;
174 alpha-*-linux*) enable_shared=yes ;;
175 mips-sgi-irix5*) enable_shared=yes ;;
176 *) enable_shared=no ;;
177 esac
178fi
179
180case "${enable_shared}" in
181 yes) shared=yes ;;
182 no) shared=no ;;
183 "") shared=no ;;
184 *) shared=yes ;;
185esac
186
187if [ x${shared} = xyes ]; then
188 waugh=
189 case "${host}" in
190 hppa*) waugh=config/mh-papic ;;
191 i[3456]86-*) waugh=config/mh-x86pic ;;
192 sparc64-*) waugh=config/mh-sparcpic ;;
193 *) waugh=config/mh-${host_cpu}pic ;;
194 esac
195 if [ -f ${srcdir}/${waugh} ]; then
196 if [ -n "${host_makefile_frag}" ] ; then
197 cat ${srcdir}/${host_makefile_frag} > mh-frag
198 cat ${srcdir}/${waugh} >> mh-frag
199 host_makefile_frag=mh-frag
200 else
201 host_makefile_frag=${waugh}
202 fi
203 fi
204fi
205
206# per-target:
207
208case "${target}" in
209 v810*) target_makefile_frag=config/mt-v810 ;;
210 i[3456]86-*-netware*) target_makefile_frag=config/mt-netware ;;
211# start-sanitize-r5900
212 mips64vr5900*-*-*) target_makefile_frag=config/mt-r5900 ;;
213# end-sanitize-r5900
214 powerpc-*-netware*) target_makefile_frag=config/mt-netware ;;
215esac
216
217skipdirs=
218gasdir=gas
219use_gnu_ld=
220use_gnu_as=
221
222# some tools are so dependent upon X11 that if we're not building with X,
223# it's not even worth trying to configure, much less build, that tool.
224
225case ${with_x} in
226 yes | "") # the default value for this tree is that X11 is available
227 ;;
228 no)
229 skipdirs="${skipdirs} tk gash"
230 ;;
231 *)
232 echo "*** bad value \"${with_x}\" for -with-x flag; ignored" 1>&2
233 ;;
234esac
235
236# Some tools are only suitable for building in a "native" situation.
237# Those are added when we have a host==target configuration. For cross
238# toolchains, we add some directories that should only be useful in a
239# cross-compiler.
240
241is_cross_compiler=
242
243if [ x"${host}" = x"${target}" ] ; then
244 # when doing a native toolchain, don't build the targets
245 # that are in the 'cross only' list
246 skipdirs="${skipdirs} ${cross_only}"
247 is_cross_compiler=no
248 target_subdir=.
249else
250 # similarly, don't build the targets in the 'native only'
251 # list when building a cross compiler
252 skipdirs="${skipdirs} ${native_only}"
253 is_cross_compiler=yes
254 target_subdir=${target_alias}
255 if [ ! -d ${target_subdir} ] ; then
256 if mkdir ${target_subdir} ; then true
257 else
258 echo "'*** could not make ${PWD=`pwd`}/${target_subdir}" 1>&2
259 exit 1
260 fi
261 fi
262fi
263
264copy_dirs=
265
266# Handle --with-headers=XXX. The contents of the named directory are
267# copied to $(tooldir)/sys-include.
268if [ x"${with_headers}" != x ]; then
269 if [ x${is_cross_compiler} = xno ]; then
270 echo 1>&2 '***' --with-headers is only supported when cross compiling
271 exit 1
272 fi
273 case "${exec_prefixoption}" in
274 "") x=${prefix} ;;
275 *) x=${exec_prefix} ;;
276 esac
277 copy_dirs="${copy_dirs} ${with_headers} $x/${target_alias}/sys-include"
278fi
279
280# Handle --with-libs=XXX. Multiple directories are permitted. The
281# contents are copied to $(tooldir)/lib.
282if [ x"${with_libs}" != x ]; then
283 if [ x${is_cross_compiler} = xno ]; then
284 echo 1>&2 '***' --with-libs is only supported when cross compiling
285 exit 1
286 fi
287 # Copy the libraries in reverse order, so that files in the first named
288 # library override files in subsequent libraries.
289 case "${exec_prefixoption}" in
290 "") x=${prefix} ;;
291 *) x=${exec_prefix} ;;
292 esac
293 for l in ${with_libs}; do
294 copy_dirs="$l $x/${target_alias}/lib ${copy_dirs}"
295 done
296fi
297
298# If both --with-headers and --with-libs are specified, default to
299# --without-newlib.
300if [ x"${with_headers}" != x ] && [ x"${with_libs}" != x ]; then
301 if [ x"${with_newlib}" = x ]; then
302 with_newlib=no
303 fi
304fi
305
306# Recognize --with-newlib/--without-newlib.
307if [ x${with_newlib} = xno ]; then
308 skipdirs="${skipdirs} target-newlib"
309elif [ x${with_newlib} = xyes ]; then
310 skipdirs=`echo " ${skipdirs} " | sed -e 's/ target-newlib / /'`
311fi
312
313# Default to using --with-stabs for certain targets.
314if [ x${with_stabs} = x ]; then
315 case "${target}" in
316 mips*-*-irix6*)
317 ;;
318 mips*-*-* | alpha*-*-osf* | i[3456]86*-*-sysv4* | i[3456]86*-*-unixware*)
319 with_stabs=yes;
320 withoptions="${withoptions} --with-stabs"
321 ;;
322 esac
323fi
324
325# Handle ${copy_dirs}
326set fnord ${copy_dirs}
327shift
328while [ $# != 0 ]; do
329 if [ -f $2/COPIED ] && [ x"`cat $2/COPIED`" = x"$1" ]; then
330 :
331 else
332 echo Copying $1 to $2
333
334 # Use the install script to create the directory and all required
335 # parent directories.
336 if [ -d $2 ]; then
337 :
338 else
339 echo >config.temp
340 ${srcdir}/install.sh -c -m 644 config.temp $2/COPIED
341 fi
342
343 # Copy the directory, assuming we have tar.
344 # FIXME: Should we use B in the second tar? Not all systems support it.
345 (cd $1; tar -cf - .) | (cd $2; tar -xpf -)
346
347 # It is the responsibility of the user to correctly adjust all
348 # symlinks. If somebody can figure out how to handle them correctly
349 # here, feel free to add the code.
350
351 echo $1 > $2/COPIED
352 fi
353 shift; shift
354done
355
356# Configure extra directories which are host specific
357
358case "${host}" in
359 i[3456]86-*-go32*)
360 configdirs="$configdirs dosrel" ;;
361 *-cygwin32*)
362 configdirs="$configdirs dosrel" ;;
363esac
364
365# Remove more programs from consideration, based on the host or
366# target this usually means that a port of the program doesn't
367# exist yet.
368
369noconfigdirs=""
370
371case "${host}" in
372 i[3456]86-*-vsta)
373 noconfigdirs="tcl expect dejagnu make texinfo bison patch flex byacc send-pr gprof uudecode dejagnu diff guile perl apache inet"
374 ;;
375 i[3456]86-*-go32)
376 noconfigdirs="tcl tk expect dejagnu make texinfo bison patch flex byacc send-pr gprof uudecode dejagnu diff guile perl apache inet"
377 ;;
378 *-*-cygwin32)
379 noconfigdirs="tk tcl expect dejagnu cvs autoconf bison send-pr gprof rcs guile perl texinfo apache inet"
380 ;;
381 *-*-windows*)
382# This is only used to build WinGDB...
383 configdirs="bfd gdb libiberty opcodes readline sim"
384 target_configdirs=
385 ;;
386 ppc*-*-pe)
387 noconfigdirs="patch diff make tk tcl expect dejagnu cvs autoconf texinfo bison send-pr gprof rcs guile perl apache inet"
388 ;;
389esac
390
391
392case "${target}" in
393 *-*-netware)
394 noconfigdirs="$noconfigdirs target-libg++ target-libstdc++ target-librx target-newlib target-libiberty target-libgloss"
395 ;;
396 *-*-vxworks*)
397 noconfigdirs="$noconfigdirs target-newlib target-libgloss"
398 ;;
399 alpha-dec-osf*)
400 # ld works, but does not support shared libraries. emacs doesn't
401 # work. newlib is not 64 bit ready. I'm not sure about fileutils or grep.
402 # gas doesn't generate exception information.
403 noconfigdirs="$noconfigdirs gas ld emacs fileutils grep target-newlib target-libgloss"
404 ;;
405 alpha*-*-*vms*)
406 noconfigdirs="$noconfigdirs gdb ld target-newlib target-libgloss"
407 ;;
408 alpha*-*-*)
409 # newlib is not 64 bit ready
410 noconfigdirs="$noconfigdirs target-newlib target-libgloss"
411 ;;
412# start-sanitize-arc
413 arc-*-*)
414 noconfigdirs="$noconfigdirs target-libgloss"
415 ;;
416# end-sanitize-arc
417 arm-*-pe*)
418 noconfigdirs="$noconfigdirs target-libgloss"
419 ;;
420 arm-*-coff*)
421 noconfigdirs="$noconfigdirs target-libgloss"
422 ;;
423 arm-*-riscix*)
424 noconfigdirs="$noconfigdirs ld target-libgloss"
425 ;;
426 d10v-*-*)
427 noconfigdirs="$noconfigdirs target-librx target-libg++ target-libstdc++ target-libio target-libgloss"
428 ;;
429# start-sanitize-d30v
430 d30v-*-*)
431 noconfigdirs="$noconfigdirs tcl tk expect gcc gdb newlib target-librx target-libg++ target-libstdc++ target-libio target-libgloss"
432 ;;
433# end-sanitize-d30v
434 h8300*-*-* | \
435 h8500-*-*)
436 noconfigdirs="$noconfigdirs target-libg++ target-libstdc++ target-libio target-librx target-libgloss"
437 ;;
438 hppa*-*-*elf* | \
439 hppa*-*-lites*)
440 # Do configure ld/binutils/gas for this case.
441 ;;
442 hppa*-*-*)
443 # HP's C compiler doesn't handle Emacs correctly (but on BSD and Mach
444 # cc is gcc, and on any system a user should be able to link cc to
445 # whatever they want. FIXME, emacs emacs19).
446 case "${CC}" in
447 "" | cc*) noconfigdirs="$noconfigdirs emacs emacs19" ;;
448 *) ;;
449 esac
450 noconfigdirs="$noconfigdirs ld shellutils"
451 ;;
452 i[3456]86-*-go32)
453 # but don't build gdb
454 noconfigdirs="$noconfigdirs gdb target-libg++ target-libstdc++ target-libio target-librx"
455 ;;
456 *-*-cygwin32)
457 target_configdirs="$target_configdirs target-winsup"
458 noconfigdirs="$noconfigdirs tcl tk expect target-libgloss"
459 # always build newlib.
460 skipdirs=`echo " ${skipdirs} " | sed -e 's/ target-newlib / /'`
461
462 # Can't build gdb for cygwin32 if not native.
463 case "${host}" in
464 *-*-cygwin32) ;; # keep gdb
465 *) noconfigdirs="$noconfigdirs gdb"
466 esac
467 ;;
468 i[3456]86-*-pe)
469 noconfigdirs="$noconfigdirs target-libg++ target-libstdc++ target-libio target-librx target-libgloss"
470 ;;
471 i[3456]86-*-sco3.2v5*)
472 # The linker does not yet know about weak symbols in COFF,
473 # and is not configured to handle mixed ELF and COFF.
474 noconfigdirs="$noconfigdirs gprof ld target-libgloss"
475 ;;
476 i[3456]86-*-sco*)
477 noconfigdirs="$noconfigdirs gprof target-libgloss"
478 ;;
479 i[3456]86-*-solaris2*)
480 # The linker does static linking correctly, but the Solaris C library
481 # has bugs such that some important functions won't work when statically
482 # linked. (See man pages for getpwuid, for example.)
483 noconfigdirs="$noconfigdirs ld target-libgloss"
484 ;;
485 i[3456]86-*-sysv4*)
486 # The SYSV4 C compiler doesn't handle Emacs correctly
487 case "${CC}" in
488 "" | cc*) noconfigdirs="$noconfigdirs emacs emacs19" ;;
489 *) ;;
490 esac
491 # but that's okay since emacs doesn't work anyway
492 noconfigdirs="$noconfigdirs emacs emacs19 target-libgloss"
493 ;;
494 mn10200-*-*)
495 noconfigdirs="$noconfigdirs target-libgloss"
496 ;;
497 mn10300-*-*)
498 noconfigdirs="$noconfigdirs target-libgloss"
499 ;;
500 powerpc-*-aix*)
501 # copied from rs6000-*-* entry
502 noconfigdirs="$noconfigdirs gprof cvs target-libgloss"
503 # This is needed until gcc and ld are fixed to work together.
504 use_gnu_ld=no
505 ;;
506 powerpc*-*-winnt* | powerpc*-*-pe* | ppc*-*-pe)
507 target_configdirs="$target_configdirs target-winsup"
508 noconfigdirs="$noconfigdirs gdb tcl tk make expect target-libgloss"
509 # always build newlib.
510 skipdirs=`echo " ${skipdirs} " | sed -e 's/ target-newlib / /'`
511 ;;
512 # This is temporary until we can link against shared libraries
513 powerpcle-*-solaris*)
514 noconfigdirs="$noconfigdirs gdb sim make tcl tk expect"
515 ;;
516 rs6000-*-lynxos*)
517 # The CVS server code doesn't work on the RS/6000
518 # Newlib makes problems for libg++ in crosses.
519 noconfigdirs="$noconfigdirs target-newlib gprof cvs"
520 ;;
521 rs6000-*-aix*)
522 noconfigdirs="$noconfigdirs gprof"
523 # This is needed until gcc and ld are fixed to work together.
524 use_gnu_ld=no
525 ;;
526 rs6000-*-*)
527 noconfigdirs="$noconfigdirs gprof"
528 ;;
529 m68k-apollo-*)
530 noconfigdirs="$noconfigdirs ld binutils gprof target-libgloss"
531 ;;
532 mips*-*-irix5*)
533 # The GNU linker does not support shared libraries.
534 # emacs is emacs 18, which does not work on Irix 5 (emacs19 does work)
535 noconfigdirs="$noconfigdirs ld gprof emacs target-libgloss"
536 ;;
537 mips*-*-irix6*)
538 # The GNU linker does not support shared libraries.
539 # emacs is emacs 18, which does not work on Irix 5 (emacs19 does work)
540 noconfigdirs="$noconfigdirs ld gas gprof emacs target-libgloss"
541 ;;
542 mips*-dec-bsd*)
543 noconfigdirs="$noconfigdirs gprof target-libgloss"
544 ;;
545 mips*-*-bsd*)
546 noconfigdirs="$noconfigdirs gprof target-libgloss"
547 ;;
548 mips*-*-*)
549 noconfigdirs="$noconfigdirs gprof"
550 ;;
551 romp-*-*)
552 noconfigdirs="$noconfigdirs bfd binutils ld gas opcodes target-libgloss"
553 ;;
554 sh-*-*)
555 case "${host}" in
556 i[3456]86-*-vsta) ;; # don't add gprof back in
557 i[3456]86-*-go32) ;; # don't add gprof back in
558 *) skipdirs=`echo " ${skipdirs} " | sed -e 's/ gprof / /'` ;;
559 esac
560 noconfigdirs="$noconfigdirs target-libgloss"
561 ;;
562 sparc-*-sunos4*)
563 if [ x${is_cross_compiler} != xno ] ; then
564 noconfigdirs="$noconfigdirs gdb gdbtest target-newlib target-libgloss"
565 else
566 use_gnu_ld=no
567 fi
568 ;;
569# start-sanitize-tic80
570 tic80-*-*)
571 noconfigdirs="$noconfigdirs gdb ld target-libio target-libg++ target-libstdc++ target-libgloss"
572 ;;
573# end-sanitize-tic80
574 v810-*-*)
575 noconfigdirs="$noconfigdirs bfd binutils gas gcc gdb ld target-libio target-libg++ target-libstdc++ opcodes target-libgloss"
576 ;;
577# start-sanitize-v850
578 v850-*-*)
579 noconfigdirs="$noconfigdirs target-libgloss"
580 ;;
581# end-sanitize-v850
582 vax-*-vms)
583 noconfigdirs="$noconfigdirs bfd binutils gdb ld target-newlib opcodes target-libgloss"
584 ;;
585 vax-*-*)
586 noconfigdirs="$noconfigdirs target-newlib target-libgloss"
587 ;;
588 *-*-lynxos*)
589 # Newlib makes problems for libg++ in crosses.
590 noconfigdirs="$noconfigdirs target-newlib target-libgloss"
591 ;;
592 *-*-macos* | \
593 *-*-mpw*)
594 # Macs want a resource compiler.
595 configdirs="$configdirs grez"
596 ;;
597esac
598
599# targets that need a second pass
600case "${target}" in
601 *-gm-magic*)
602 noconfigdirs="$noconfigdirs target-libgloss"
603 ;;
604esac
605
606# If we aren't building newlib, then don't build libgloss, since libgloss
607# depends upon some newlib header files.
608case "${noconfigdirs}" in
609 *target-libgloss*) ;;
610 *target-newlib*) noconfigdirs="$noconfigdirs target-libgloss" ;;
611esac
612
613# If we are building a Canadian Cross, discard tools that can not be built
614# using a cross compiler. FIXME: These tools should be fixed.
615if [ "${build}" != "${host}" ]; then
616 noconfigdirs="$noconfigdirs tcl tk expect dejagnu"
617fi
618
619# Make sure we don't let GNU ld be added if we didn't want it.
620if [ x$with_gnu_ld = xno ]; then
621 use_gnu_ld=no
622 noconfigdirs="$noconfigdirs ld"
623fi
624
625# Make sure we don't let GNU as be added if we didn't want it.
626if [ x$with_gnu_as = xno ]; then
627 use_gnu_as=no
628 noconfigdirs="$noconfigdirs gas"
629fi
630
631# Remove the entries in $skipdirs and $noconfigdirs from $configdirs and
632# $target_configdirs.
633# If we have the source for $noconfigdirs entries, add them to $notsupp.
634
635notsupp=""
636for dir in . $skipdirs $noconfigdirs ; do
637 dirname=`echo $dir | sed -e s/target-//g`
638 if [ $dir != . ] && echo " ${configdirs} " | grep " ${dir} " >/dev/null 2>&1; then
639 configdirs=`echo " ${configdirs} " | sed -e "s/ ${dir} / /"`
640 if [ -r $srcdir/$dirname/configure ] \
641 || [ -r $srcdir/$dirname/configure.in ]; then
642 if echo " ${skipdirs} " | grep " ${dir} " >/dev/null 2>&1; then
643 true
644 else
645 notsupp="$notsupp $dir"
646 fi
647 fi
648 fi
649 if [ $dir != . ] && echo " ${target_configdirs} " | grep " ${dir} " >/dev/null 2>&1; then
650 target_configdirs=`echo " ${target_configdirs} " | sed -e "s/ ${dir} / /"`
651 if [ -r $srcdir/$dirname/configure ] \
652 || [ -r $srcdir/$dirname/configure.in ]; then
653 if echo " ${skipdirs} " | grep " ${dir} " >/dev/null 2>&1; then
654 true
655 else
656 notsupp="$notsupp $dir"
657 fi
658 fi
659 fi
660done
661
662# Sometimes the tools are distributed with libiberty but with no other
663# libraries. In that case, we don't want to build target-libiberty.
664if [ -n "${target_configdirs}" ]; then
665 others=
666 for i in `echo ${target_configdirs} | sed -e s/target-//g` ; do
667 if [ "$i" != "libiberty" ]; then
668 if [ -r $srcdir/$i/configure ] || [ -r $srcdir/$i/configure.in ]; then
669 others=yes;
670 break;
671 fi
672 fi
673 done
674 if [ -z "${others}" ]; then
675 target_configdirs=
676 fi
677fi
678
679# Deconfigure all subdirectories, in case we are changing the
680# configuration from one where a subdirectory is supported to one where it
681# is not.
682if [ -z "${norecursion}" -a -n "${configdirs}" ]; then
683 for i in `echo ${configdirs} | sed -e s/target-//g` ; do
684 rm -f $i/Makefile
685 done
686fi
687if [ -z "${norecursion}" -a -n "${target_configdirs}" ]; then
688 for i in `echo ${target_configdirs} | sed -e s/target-//g` ; do
689 rm -f ${target_subdir}/$i/Makefile
690 done
691fi
692
693# Produce a warning message for the subdirs we can't configure.
694# This isn't especially interesting in the Cygnus tree, but in the individual
695# FSF releases, it's important to let people know when their machine isn't
696# supported by the one or two programs in a package.
697
698if [ -n "${notsupp}" ] && [ -z "${norecursion}" ]; then
699 # If $appdirs is non-empty, at least one of those directories must still
700 # be configured, or we error out. (E.g., if the gas release supports a
701 # specified target in some subdirs but not the gas subdir, we shouldn't
702 # pretend that all is well.)
703 if [ -n "$appdirs" ]; then
704 for dir in $appdirs ; do
705 if [ -r $dir/Makefile.in ]; then
706 if echo " ${configdirs} " | grep " ${dir} " >/dev/null 2>&1; then
707 appdirs=""
708 break
709 fi
710 if echo " ${target_configdirs} " | grep " ${dir} " >/dev/null 2>&1; then
711 appdirs=""
712 break
713 fi
714 fi
715 done
716 if [ -n "$appdirs" ]; then
717 echo "*** This configuration is not supported by this package." 1>&2
718 exit 1
719 fi
720 fi
721 # Okay, some application will build, or we don't care to check. Still
722 # notify of subdirs not getting built.
723 echo "*** This configuration is not supported in the following subdirectories:" 1>&2
724 echo " ${notsupp}" 1>&2
725 echo " (Any other directories should still work fine.)" 1>&2
726fi
727
728# Set with_gnu_as and with_gnu_ld as appropriate.
729#
730# This is done by determining whether or not the appropriate directory
731# is available, and by checking whether or not specific configurations
732# have requested that this magic not happen.
733#
734# The command line options always override the explicit settings in
735# configure.in, and the settings in configure.in override this magic.
736#
737# If the default for a toolchain is to use GNU as and ld, and you don't
738# want to do that, then you should use the --without-gnu-as and
739# --without-gnu-ld options for the configure script.
740
741if [ x${use_gnu_as} = x ] ; then
742 if [ x${with_gnu_as} != xno ] && echo " ${configdirs} " | grep " ${gasdir} " > /dev/null 2>&1 && [ -d ${srcdir}/${gasdir} ] ; then
743 with_gnu_as=yes
744 withoptions="$withoptions --with-gnu-as"
745 fi
746fi
747
748if [ x${use_gnu_ld} = x ] ; then
749 if [ x${with_gnu_ld} != xno ] && echo " ${configdirs} " | grep " ld " > /dev/null 2>&1 && [ -d ${srcdir}/ld ] ; then
750 with_gnu_ld=yes
751 withoptions="$withoptions --with-gnu-ld"
752 fi
753fi
754
755# If using newlib, add --with-newlib to the withoptions so that gcc/configure
756# can detect this case.
757
758if [ x${with_newlib} != xno ] && echo " ${target_configdirs} " | grep " target-newlib " > /dev/null 2>&1 && [ -d ${srcdir}/newlib ] ; then
759 with_newlib=yes
760 withoptions="$withoptions --with-newlib"
761fi
762
763if [ x${shared} = xyes ]; then
764 case "${target}" in
765 hppa*) target_makefile_frag=config/mt-papic ;;
766 i[3456]86-*) target_makefile_frag=config/mt-x86pic ;;
767 *) target_makefile_frag=config/mt-${target_cpu}pic ;;
768 esac
769fi
770
771# post-target:
772
773# Make sure that the compiler is able to generate an executable. If it
774# can't, we are probably in trouble. We don't care whether we can run the
775# executable--we might be using a cross compiler--we only care whether it
776# can be created. At this point the main configure script has set CC.
777echo "int main () { return 0; }" > conftest.c
778${CC} -o conftest ${CFLAGS} ${CPPFLAGS} ${LDFLAGS} conftest.c
779if [ $? = 0 ] && [ -s conftest ]; then
780 :
781else
782 echo 1>&2 "*** The command '${CC} -o conftest ${CFLAGS} ${CPPFLAGS} ${LDFLAGS} conftest.c' failed."
783 echo 1>&2 "*** You must set the environment variable CC to a working compiler."
784 rm -f conftest*
785 exit 1
786fi
787rm -f conftest*
788
789# The Solaris /usr/ucb/cc compiler does not appear to work.
790case "${host}" in
791 sparc-sun-solaris2*)
792 CCBASE="`echo ${CC-cc} | sed 's/ .*$//'`"
793 if [ "`/usr/bin/which $CCBASE`" = "/usr/ucb/cc" ] ; then
794 could_use=
795 [ -d /opt/SUNWspro/bin ] && could_use="/opt/SUNWspro/bin"
796 if [ -d /opt/cygnus/bin ] ; then
797 if [ "$could_use" = "" ] ; then
798 could_use="/opt/cygnus/bin"
799 else
800 could_use="$could_use or /opt/cygnus/bin"
801 fi
802 fi
803 if [ "$could_use" = "" ] ; then
804 echo "Warning: compilation may fail because you're using"
805 echo "/usr/ucb/cc. You should change your PATH or CC "
806 echo "variable and rerun configure."
807 else
808 echo "Warning: compilation may fail because you're using"
809 echo "/usr/ucb/cc, when you should use the C compiler from"
810 echo "$could_use. You should change your"
811 echo "PATH or CC variable and rerun configure."
812 fi
813 fi
814 ;;
815esac
816
817# If --enable-shared was set, we must set LD_LIBRARY_PATH so that the
818# binutils tools will find libbfd.so.
819if [ "${shared}" = "yes" ]; then
820 sed -e 's/^SET_LIB_PATH[ ]*=.*$/SET_LIB_PATH = $(REALLY_SET_LIB_PATH)/' \
821 Makefile > Makefile.tem
822 rm -f Makefile
823 mv -f Makefile.tem Makefile
824
825 case "${host}" in
826 *-*-hpux*)
827 sed -e 's/RPATH_ENVVAR[ ]*=.*$/RPATH_ENVVAR = SHLIB_PATH/' \
828 Makefile > Makefile.tem
829 rm -f Makefile
830 mv -f Makefile.tem Makefile
831 ;;
832 esac
833fi
834
835# Record target_configdirs and the configure arguments in Makefile.
836target_configdirs=`echo "${target_configdirs}" | sed -e 's/target-//g'`
837targargs=`echo "${arguments}" | \
838 sed -e 's/--norecursion//' \
839 -e 's/--cache[a-z-]*=[^ ]*//' \
840 -e 's/--ho[a-z-]*=[^ ]*//' \
841 -e 's/--ta[a-z-]*=[^ ]*//'`
842
843# Passing a --with-cross-host argument lets the target libraries know
844# whether they are being built with a cross-compiler or being built
845# native. However, it would be better to use other mechanisms to make the
846# sorts of decisions they want to make on this basis. Please consider
847# this option to be deprecated. FIXME.
848if [ x${is_cross_compiler} = xyes ]; then
849 targargs="--with-cross-host=${host_alias} ${targargs}"
850fi
851
852targargs="--host=${target_alias} ${targargs}"
853sed -e "s:^TARGET_CONFIGDIRS[ ]*=.*$:TARGET_CONFIGDIRS = ${target_configdirs}:" \
854 -e "s%^CONFIG_ARGUMENTS[ ]*=.*$%CONFIG_ARGUMENTS = ${targargs}%" \
855 -e "s%^TARGET_SUBDIR[ ]*=.*$%TARGET_SUBDIR = ${target_subdir}%" \
856 Makefile > Makefile.tem
857rm -f Makefile
858mv -f Makefile.tem Makefile
859
860#
861# Local Variables:
862# fill-column: 131
863# End:
864#
This page took 0.046768 seconds and 4 git commands to generate.